MODULE Trace;

IMPORT
  SYSTEM;

VAR
  Send*: PROCEDURE (c: ARRAY OF CHAR);
  Color*: PROCEDURE (c: SHORTINT);

PROCEDURE Char* (c: CHAR);
VAR
  str: ARRAY 2 OF CHAR;
BEGIN
  IF Send = NIL THEN RETURN END;
  str[0] := c;
  str[1] := 0X;
  Send(str);
END Char;

PROCEDURE String* (str: ARRAY OF CHAR);
BEGIN
  IF Send = NIL THEN RETURN END;
  Send(str)
END String;

PROCEDURE Boolean* (x : BOOLEAN);
BEGIN
  IF x THEN String ("TRUE") ELSE String ("FALSE") END;
END Boolean;

PROCEDURE Ln*;
VAR
  str: ARRAY 3 OF CHAR;
BEGIN
  str[0] := 0DX;
  str[1] := 0AX;
  str[2] := 0X;
  String(str);
END Ln;

PROCEDURE Error* (str: ARRAY OF CHAR);
BEGIN
  IF Send = NIL THEN RETURN END;
  IF Color # NIL THEN Red END;
  Send(str);
  IF Color # NIL THEN Default END;
END Error;

PROCEDURE IntToStr(i: LONGINT; VAR s: ARRAY OF CHAR);
VAR
  k, j, x0: LONGINT;
  a: ARRAY 10 OF CHAR;
BEGIN
  k := 0;
  IF i < 0 THEN
    IF i = MIN(LONGINT) THEN
      COPY("-2147483648", s);
      RETURN
    ELSE
      x0 := -i
    END
  ELSE
    x0 := i
  END;
  REPEAT
    a[k] := CHR(x0 MOD 10 + 30H);
    x0 := x0 DIV 10;
    INC(k);
  UNTIL x0 = 0;
  IF i < 0 THEN
    s[0] := "-";
    j := 1;
  ELSE
    j := 0;
  END;
  REPEAT
    DEC(k);
    s[j] := a[k];
    INC(j)
  UNTIL k = 0;
  s[j] := 0X
END IntToStr;

PROCEDURE Int*(x: LONGINT);
VAR
  s: ARRAY 16 OF CHAR;
BEGIN
  IntToStr(x, s);
  String(s);
END Int;

PROCEDURE Hex*(x,w: LONGINT);
CONST
  sz = SIZE(LONGINT);
VAR
  i,n: LONGINT;
  buf: ARRAY 2*sz+2 OF CHAR;
  str: ARRAY w+2 OF CHAR;
  neg: BOOLEAN;
  c: LONGINT;
BEGIN

  IF w >= 0 THEN

    i:= 0;
    IF x < 0 THEN
      neg := TRUE;
      x :=-x
    ELSIF x=0 THEN
      buf := "0"
    ELSE
      neg := FALSE
    END;

    i := 0;
    REPEAT
      c := x MOD 10H;
      IF c < 10 THEN
        buf[i] := CHR(c+ORD("0"))
      ELSE
        buf[i] := CHR(c-10+ORD("A"))
      END;
      x := x DIV 10H;
      INC(i);
    UNTIL (i = 2 * sz) OR (x=0);

    IF c > 9 THEN buf[i] := "0"; INC(i) END;
    IF neg   THEN buf[i] := "-"; INC(i) END;
    n:=0;
    WHILE(w > i) DO str[n]:="0"; DEC(w); INC(n);END;
    REPEAT
      DEC(i);
      str[n] := buf[i];
      INC(n);
    UNTIL i=0;

    INC(n);
    str[n] := 0X;
    String(str);

  ELSE
    w := -w;
    WHILE(w>2*sz) DO
      Char(" ");
      DEC(w);
    END;
    buf[w] := 0X;
    REPEAT
      DEC(w);
      c := x MOD 10H;
      IF c <10 THEN
        buf[w] := CHR(c+ORD("0"))
      ELSE
        buf[w] := CHR(c-10+ORD("A"))
      END;
      x := x DIV 10H;
    UNTIL w = 0;
    String(buf);
  END;

END Hex;

PROCEDURE Set*(x: SET);
VAR
  first: BOOLEAN;
  i,n,j: LONGINT;
  str: ARRAY 64 OF CHAR;
  s  : ARRAY 10 OF CHAR;
BEGIN
  first := TRUE;
  n := 0;
  str[n] := "{";
  INC(n);
  FOR i := 0 TO MAX(SET) DO
    IF i IN x THEN
      IF ~first THEN
        str[n] := ",";
        INC(n);
      ELSE
        first := FALSE
      END;
      IntToStr(i,s);
      j := 0;
      WHILE s[j] # 0X DO
        str[n] := s[j];
        INC(j);
        INC(n);
      END;
    END;
  END;
  str[n] := "}";
  str[n+1] := 0X;
  String(str);
END Set;

PROCEDURE Olive*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (6);
END Olive;

PROCEDURE Gray*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (8);
END Gray;

PROCEDURE Blue*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (9);
END Blue;

PROCEDURE Green*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (10);
END Green;

PROCEDURE Tean*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (11);
END Tean;

PROCEDURE Red*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (12);
END Red;

PROCEDURE Pink*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (13);
END Pink;

PROCEDURE Yellow*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (14);
END Yellow;

PROCEDURE Default*;
BEGIN
  IF Color = NIL THEN RETURN END;
  Color (7);
END Default;

END Trace.

