MODULE Commands;

IMPORT
  SYSTEM, Trace, Kernel, Kernel32, Files, Modules;

VAR
  hOut*: Kernel32.HANDLE;
  moduleCS: Kernel.CriticalSection;
  workPath*: Files.FileName;

PROCEDURE Length* (str: ARRAY OF CHAR): LONGINT;
VAR
  len, maxLen: LONGINT;
BEGIN
  maxLen := LEN(str);
  len := 0;
  WHILE (len < maxLen) & (str[len] # 0X) DO INC(len) END;
  RETURN len;
END Length;

PROCEDURE Send* (str: ARRAY OF CHAR);
VAR
  n,i,c: LONGINT;
BEGIN
  n := Length(str);

  i:=0;
  WHILE (i<n) DO
    c:=ORD(str[i]);
    IF    (c>=192) & (c<=239) THEN c:=c-64;
    ELSIF (c>=240) & (c<=255) THEN c:=c-16;
    ELSIF (c=168)             THEN c:=240;
    ELSIF (c=184)             THEN c:=241;
    END;
    str[i]:=CHR(c);
    INC(i);
  END;

  Kernel32.WriteFile(hOut, str, n, n, NIL);
END Send;

PROCEDURE Color* (c: SHORTINT);
BEGIN
  Kernel32.SetConsoleTextAttribute(hOut,c);
END Color;

PROCEDURE *Shutdown();
BEGIN
  Kernel.DeleteCriticalSection(moduleCS)
END Shutdown;

PROCEDURE Call*(name: ARRAY OF CHAR; new: BOOLEAN): INTEGER;
VAR
  Mod: Modules.Module;
  P: Modules.Command;
  i, j: LONGINT;
  res: INTEGER;
BEGIN

  res := 1;
  i := 0;
  j := 0;

  WHILE name[j] # 0X DO
    IF name[j] = "." THEN
      i := j
    END;
    INC(j);
  END;

  IF i = 0 THEN
    i := j;
    name[j+1] := 0X
  END;

  name[i] := 0X;

  IF new THEN Modules.Free(name, FALSE) END;

  Mod := Modules.ThisMod(name);

  IF Modules.res = 0 THEN

    INC(i);
    j := i;
    WHILE name[j] # 0X DO
      name[j - i] := name[j];
      INC(j)
    END;

    name[j - i] := 0X;

    P := Modules.ThisCommand(Mod, name);

    IF Modules.res = 0 THEN
      P();
      res := 0;
    ELSE
      res := Modules.res;
    END;

  ELSE
    res := Modules.res;
  END;

  RETURN res;
END Call;

BEGIN
  Kernel.InitializeCriticalSection(moduleCS);
  Kernel.EnterCriticalSection(moduleCS);
  Kernel.InstallTermHandler(Shutdown);

  Kernel32.GetCurrentDirectory(LEN(workPath), workPath);
  hOut := Kernel32.GetStdHandle(Kernel32.STD_OUTPUT_HANDLE);
  Trace.Send := Send;
  Trace.Color := Color;

  (*Kernel32.SetCurrentDirectory(workPath);*)
  Kernel.LeaveCriticalSection(moduleCS);
END Commands.

