MODULE Kernel32;

IMPORT
  SYSTEM, Kernel;

CONST
  NULL*                       = 0;
  False*                      = NULL;
  True*                       = 1;

  INVALID_HANDLE_VALUE*       = -1;

  STD_INPUT_HANDLE*           = -10;
  STD_OUTPUT_HANDLE*          = -11;
  STD_ERROR_HANDLE*           = -12;

  CREATE_NEW*                 = 1;
  OPEN_EXISTING*              = 3;

  FILE_BEGIN*                 = 0;

  FILE_GENERIC_READ*          = {0, 3, 7, 17, 20};
  FILE_GENERIC_WRITE*         = {1, 2, 4, 8, 17, 20};

  FILE_SHARE_READ*            = {0};
  FILE_SHARE_WRITE*           = {1};
  FILE_SHARE_DELETE*          = {2};

  FILE_ATTRIBUTE_NORMAL*      = {7};
  INVALID_FILE_ATTRIBUTES*    = {0..31};

  MaxPath*                    = 260;

TYPE
  BOOL*                        = LONGINT;
  ADDRESS*                     = LONGINT;
  HANDLE*                      = ADDRESS;
  HMODULE*                     = ADDRESS;
  HINSTANCE*                   = ADDRESS;
  ATOM*                        = INTEGER;
  HGLOBAL*                     = HANDLE;
  LPSTR*                       = ADDRESS;

  Object* = POINTER TO RECORD
    handle*: HANDLE;
  END;

VAR
  CloseHandle-             : PROCEDURE [WINAPI] (hObject: HANDLE): BOOL;
  CreateFile-              : PROCEDURE [WINAPI] (lpFileName: ARRAY [NOTAG] OF CHAR; dwDesiredAccess, dwShareMode: SET; lpSecurityAttributes: PTR; dwCreationDistribution: LONGINT; dwFlagsAndAttributes: SET; hTemplateFile: HANDLE): HANDLE;
  GetCurrentDirectory-     : PROCEDURE [WINAPI] (nBufferLength: LONGINT; VAR lpBuffer: ARRAY [NOTAG] OF CHAR): LONGINT;
  GetFileAttributes-       : PROCEDURE [WINAPI] (lpFileName: ARRAY [NOTAG] OF CHAR): SET;
  GetFileSize-             : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpFileSizeHigh: LONGINT): LONGINT;
  GetLastError-            : PROCEDURE [WINAPI] (): LONGINT;
  GetStdHandle-            : PROCEDURE [WINAPI] (nStdHandle: LONGINT): HANDLE;
  GetTickCount-            : PROCEDURE [WINAPI] (): LONGINT;
  ReadFile-                : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToRead: LONGINT; VAR lpNumberOfBytesRead: LONGINT; lpOverlapped: PTR): BOOL;
  SetConsoleTextAttribute- : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; wAttributes: LONGINT): BOOL;
  SetCurrentDirectory-     : PROCEDURE [WINAPI] (lpPathName: ARRAY [NOTAG] OF CHAR): BOOL;
  SetFilePointer-          : PROCEDURE [WINAPI] (hFile: HANDLE; lDistanceToMove: LONGINT; VAR lpDistanceToMoveHigh: LONGINT; dwMoveMethod: LONGINT): LONGINT;
  WriteFile-               : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToWrite: LONGINT; VAR lpNumberOfBytesWritten: LONGINT; lpOverlapped: PTR): BOOL;

  mod                      : Kernel.HMODULE;

BEGIN
  mod := Kernel.LoadLibrary ("Kernel32.DLL");
  Kernel.GetProcAddress(mod, "CloseHandle"             , SYSTEM.VAL(LONGINT, CloseHandle));
  Kernel.GetProcAddress(mod, "CreateFileA"             , SYSTEM.VAL(LONGINT, CreateFile));
  Kernel.GetProcAddress(mod, "GetCurrentDirectoryA"    , SYSTEM.VAL(LONGINT, GetCurrentDirectory));
  Kernel.GetProcAddress(mod, "GetFileAttributesA"      , SYSTEM.VAL(LONGINT, GetFileAttributes));
  Kernel.GetProcAddress(mod, "GetFileSize"             , SYSTEM.VAL(LONGINT, GetFileSize));
  Kernel.GetProcAddress(mod, "GetLastError"            , SYSTEM.VAL(LONGINT, GetLastError));
  Kernel.GetProcAddress(mod, "GetStdHandle"            , SYSTEM.VAL(LONGINT, GetStdHandle));
  Kernel.GetProcAddress(mod, "GetTickCount"            , SYSTEM.VAL(LONGINT, GetTickCount));
  Kernel.GetProcAddress(mod, "ReadFile"                , SYSTEM.VAL(LONGINT, ReadFile));
  Kernel.GetProcAddress(mod, "SetCurrentDirectoryA"    , SYSTEM.VAL(LONGINT, SetCurrentDirectory));
  Kernel.GetProcAddress(mod, "SetConsoleTextAttribute" , SYSTEM.VAL(LONGINT, SetConsoleTextAttribute));
  Kernel.GetProcAddress(mod, "SetFilePointer"          , SYSTEM.VAL(LONGINT, SetFilePointer));
  Kernel.GetProcAddress(mod, "WriteFile"               , SYSTEM.VAL(LONGINT, WriteFile));

END Kernel32.
