MODULE Project;

IMPORT
  SYSTEM, W := Windows, Cl := Classes, C := Controls, F := Forms, S := Stdctrls,
  E := Extctrls, G := Graphics, D := Dialogs;

TYPE
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Form = POINTER TO RECORD (F.Form)

    toolbar    : E.Toolbar;
    pagecontrol: E.Pagecontrol;
    rightpanel : C.Control;
    imagelist  : G.Imagelist;

    projects   : E.Toolpanel;
    components : E.Toolpanel;
    messages   : E.Toolpanel;

    opendialog : D.Opendialog;
    savedialog : D.Savedialog;
    printdialog: D.Printdialog;

    splitter   : E.Splitter;

    customcolor: Boolean;

    PROCEDURE & Create*(Parent: C.Control);
    VAR
      tb       : E.Toolbutton;
      i        : Longint;
      separator: Set;
      enbbtn   : Set;
      btnhints : ARRAY 25 OF Name;
    BEGIN
      Create^(Parent);

      width        := C.screen.width  * 5 DIV 6;
      height       := C.screen.height * 5 DIV 6;
      position     := C.poCenterCenter;
      showhint     := TRUE;

      customcolor  := TRUE;

      IF customcolor THEN
        color        := 0D9ECF0H;
      END;

      caption      := "Free Oberon IDE";
      iconname     := "Res\Ide.ico";

      NEW(imagelist,16,16);
      imagelist.LoadFromFile("Res\icon.bmp");

      NEW(toolbar,SELF);
      NEW(toolbar.imagelist,16,16);
      toolbar.imagelist := imagelist;

      IF customcolor THEN
        toolbar.color     := 0D9ECF0H;
        toolbar.leavecolor:= 0BFDCE5H;
        toolbar.entercolor:= 0AECFD9H;
        toolbar.downcolor := 0BBD8E1H;
        toolbar.colorizecl:= 0205060H;
      END;

      separator := {2,5,9,11,14,16,18,22,24};
      enbbtn    := {0,1,16,17,22,23,24};

      btnhints[ 0] := " ";
      btnhints[ 1] := " ";
      btnhints[ 2] := " ";
      btnhints[ 3] := " ...";
      btnhints[ 4] := " ...";
      btnhints[ 5] := "";
      btnhints[ 6] := "";
      btnhints[ 7] := "";
      btnhints[ 8] := "";
      btnhints[ 9] := "";
      btnhints[10] := "";
      btnhints[11] := "";
      btnhints[12] := " ";
      btnhints[13] := " ";
      btnhints[14] := " ";
      btnhints[15] := " ";
      btnhints[16] := "";
      btnhints[17] := "";
      btnhints[18] := "";
      btnhints[19] := "  ";
      btnhints[20] := "";
      btnhints[21] := " ";
      btnhints[22] := "";
      btnhints[23] := " ";
      btnhints[24] := "";

      FOR i:=0 TO LEN(btnhints) - 1 DO
        IF i IN separator THEN tb := toolbar.AddButton("",E.tbsSeparator); END;
        tb := toolbar.AddButton("",E.tbsButton);
        IF i<LEN(btnhints) THEN tb.hint := btnhints[i] END;
        tb.OnClick := TbClick;
        tb.imageindex := i;
        tb.tag := i;
        tb.enabled := FALSE;
        IF i IN enbbtn THEN tb.enabled := TRUE END;
      END;

      NEW(pagecontrol,SELF);
      pagecontrol.align       := C.alClient;

      IF customcolor THEN
        pagecontrol.color       := G.clWhite;
        pagecontrol.tabcolor    := 0D9ECF0H;
        pagecontrol.tabframe    := 09FD0D9H;
        pagecontrol.tableave    := 0D9ECF0H;
        pagecontrol.tabenter    := 0BFDCE5H;
        pagecontrol.tabfrenter  := 0AECFD9H;
        pagecontrol.tabdown     := pagecontrol.tabfrenter;
        pagecontrol.activeframe := 05D93A7H;
        pagecontrol.closecolor  := 089B0BFH;
        pagecontrol.closeenter  := 08080FFH;
        pagecontrol.textcolor   := pagecontrol.activeframe;
        pagecontrol.activetext  := pagecontrol.activeframe;
        pagecontrol.updowncolor := pagecontrol.tabcolor;
        pagecontrol.updownframe := pagecontrol.tabframe;
        pagecontrol.updownenter := pagecontrol.tabenter;
        pagecontrol.updowndown  := pagecontrol.tabdown;
      END;

      NEW(rightpanel,SELF);
      rightpanel.width := 220;
      rightpanel.align := C.alRight;

      NEW(projects,rightpanel);
      projects.align     := C.alTop;
      projects.tag       := 0;
      projects.OnClose   := ToolPanelClose;
      projects.caption   := " ";


      NEW(components,rightpanel);
      components.align   := C.alClient;
      components.tag     := 1;
      components.OnClose := ToolPanelClose;
      components.caption := "";

      NEW(splitter,rightpanel);
      splitter.align       := C.alTop;
      splitter.height      := 4;
      IF customcolor THEN
        splitter.color       := 0AECFD9H;
        splitter.shadowcolor := 074A6B8H;
      END;

      NEW(messages,SELF);
      messages.align     := C.alBottom;
      messages.tag       := 2;
      messages.height    := 100;
      messages.OnClose   := ToolPanelClose;
      messages.caption   := "";

      IF customcolor THEN
        projects.header.color       := 0BFDCE5H;
        projects.header.textcolor   := 05D93A7H;
        projects.header.closecolor  := 074A6B8H;
        projects.header.closeenter  := 08080FFH;
        projects.header.closedown   := 074A6B8H;

        components.header.color     := 0BFDCE5H;
        components.header.textcolor := 05D93A7H;
        components.header.closecolor:= 074A6B8H;
        components.header.closeenter:= 08080FFH;
        components.header.closedown := 074A6B8H;

        messages.color              := G.clWhite;
        messages.header.color       := 0BFDCE5H;
        messages.header.textcolor   := 05D93A7H;
        messages.header.closecolor  := 074A6B8H;
        messages.header.closeenter  := 08080FFH;
        messages.header.closedown   := 074A6B8H;
      END;

      NEW(splitter,SELF);
      IF customcolor THEN
        splitter.color       := 0AECFD9H;
        splitter.shadowcolor := 074A6B8H;
      END;

      NEW(splitter,SELF);
      splitter.align       := C.alBottom;
      splitter.height      := 4;
      IF customcolor THEN
        splitter.color       := 0AECFD9H;
        splitter.shadowcolor := 074A6B8H;
      END;

      projects.height    := (height - toolbar.height - messages.height) DIV 2;

      NEW(opendialog);
      NEW(savedialog);
      NEW(printdialog);

    END Create;

    PROCEDURE Destroy*;
    BEGIN
      imagelist.Destroy;
      pagecontrol:= NIL;
      opendialog := NIL;
      savedialog := NIL;
      printdialog:= NIL;
      Destroy^;
    END Destroy;

    PROCEDURE TbClick*(Sender: C.Object);
    VAR
      name: Name;
    BEGIN
      CASE Sender(E.Toolbutton).tag OF
      | 0 :
        name := "Module";
        Cl.Append(Cl.IntToStr(pagecontrol.count+1),name);
        Cl.Append(".mod",name);
        pagecontrol.NewPage(name);
      | 1 : IF opendialog.Execute()  THEN END;
      | 4 : IF savedialog.Execute()  THEN END;
      | 16: form2.Show;
      | 17: form2.Show;
      | 22: IF printdialog.Execute() THEN END;
      | 24: Close;
      ELSE
      END;
    END TbClick;

    PROCEDURE ToolPanelClose*(Sender: C.Object);
    VAR
      name: Name;
    BEGIN
      CASE Sender(E.Toolpanel).tag OF
      | 0 : W.MessageBox(0,"0","Tag 0",{});
      | 1 : W.MessageBox(0,"1","Tag 1",{});
      | 2 : W.MessageBox(0,"2","Tag 2",{});
      ELSE
      END;
    END ToolPanelClose;

  END;

VAR
  form : Form;
  form2: F.Form;

BEGIN
  NEW(form,NIL);
  form.Show;

  NEW(form2,NIL);

  C.Run;
END Project.




