MODULE Extctrls;

IMPORT
  SYSTEM, Trace, W := Windows, Cl := Classes, C := Controls, G := Graphics;

CONST
  tbsButton*   = 1;
  tbsSeparator*= 2;

  tbColor*     = TRUE;
  tbGray*      = FALSE;

TYPE
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Panel* = POINTER TO RECORD (C.Control)

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Panel";
      width        := 150;
      height       := 250;
      color        := G.clBtnFace;
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      dc    : W.HDC;
      size  : W.Size;
    BEGIN
      dc := W.GetDC(handle);
      W.SetBkMode(dc,W.TRANSPARENT);
      W.SetTextColor(dc,font.color);
      W.SelectObject(dc, font.handle);
      W.GetTextExtentPoint32(dc,SYSTEM.ADR(caption),Cl.Length(caption),size);
      W.ExtTextOut(dc,(width - size.cx) DIV 2, (height - size.cy) DIV 2, W.ETO_CLIPPED, NIL, SYSTEM.ADR(caption),Cl.Length(caption), NIL);
      G.Frame3D(dc,0,0,width-1,height-1,G.clWhite,G.clGray);
      W.ReleaseDC(handle,dc);
    END WMPaint;

    PROCEDURE WMEraseBkgnd*(VAR message: C.Message);
    BEGIN
      message.result := 0;
    END WMEraseBkgnd;

  END;

  Header* = POINTER TO RECORD (C.Customcontrol)

    textcolor*  : Longint;
    closecolor* : Longint;
    closeenter* : Longint;
    closedown*  : Longint;

    closerect   : W.Rect;
    cscolor     : Longint;
    csactive    : Boolean;

    OnClose*    : C.NotifyEvent;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Header";
      width        := 150;
      height       := 27;
      align        := C.alTop;
      color        := 0D2D2D2H;
      textcolor    := G.clGray;

      closecolor   := G.clMedGray;
      closeenter   := G.clGray;
      closedown    := G.clSilver;
      cscolor      := closecolor;
      csactive     := FALSE;
    END Create;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      cscolor      := closecolor;
      csactive     := FALSE;
      W.InvalidateRect(handle,closerect,W.False);
    END WMMouseLeave;

    PROCEDURE WMMouseDown*(VAR message: C.Message);
    BEGIN
      WMMouseDown^(message);
      IF csactive THEN
        cscolor      := closedown;
        W.InvalidateRect(handle,closerect,W.False);
      END;
    END WMMouseDown;

    PROCEDURE WMMouseMove*(VAR message: C.Message);
    VAR
      x,y,c : Longint;
    BEGIN
      WMMouseMove^(message);
      x := C.LoWord(message.lparam);
      y := C.HiWord(message.lparam);
      c := cscolor;
      IF C.XYInRect(x,y,closerect) THEN
        cscolor      := closeenter;
        csactive     := TRUE;
      ELSE
        cscolor      := closecolor;
        csactive     := FALSE;
      END;
      IF c # cscolor THEN
        W.InvalidateRect(handle,closerect,W.False);
      END;
    END WMMouseMove;

    PROCEDURE WMMouseUp*(VAR message: C.Message);
    BEGIN
      WMMouseUp^(message);
      IF csactive THEN
        IF OnClose # NIL THEN OnClose(SELF) END;
      END;
    END WMMouseUp;

    PROCEDURE DrawClose(rect: W.Rect);
    VAR
      cx,cy,r, offset: Longint;
    BEGIN
      r := (rect.right - rect.left) DIV 2;
      cx := rect.right  - r;
      cy := rect.bottom - r;
      canvas.AntialiasCircle(cx,cy,r,cscolor,cscolor,TRUE);

      offset := 5;
      canvas.Line(cx - r + offset,cy - r + offset, cx + r - offset, cy + r - offset,color);
      canvas.Line(cx - r + offset,cy - r + offset + 1, cx + r - offset - 1, cy + r - offset,color);
      canvas.Line(cx - r + offset +1,cy - r + offset, cx + r - offset, cy + r - offset - 1,color);

      canvas.Line(cx + r - offset,cy - r + offset, cx - r + offset, cy + r - offset,color);
      canvas.Line(cx + r - offset,cy - r + offset +1, cx - r + offset + 1, cy + r - offset,color);
      canvas.Line(cx + r - offset - 1,cy - r + offset, cx - r + offset, cy + r - offset - 1,color);

    END DrawClose;

    PROCEDURE Paint*;
    VAR
      r: Longint;
    BEGIN
      IF (owner # NIL) & (caption # owner.caption) THEN
        caption := owner.caption;
      END;
      canvas.font.color := textcolor;
      canvas.TextOut(5,(height - canvas.font.height) DIV 2 - 1,caption);

      r := (height - 10) DIV 2;
      closerect.left   := width - r*2 - 5;
      closerect.top    := height DIV 2 - r;
      closerect.right  := closerect.left + r*2;
      closerect.bottom := closerect.top  + r*2;
      DrawClose(closerect);
    END Paint;

  END;

  Toolpanel* = POINTER TO RECORD (C.Control)

    header*  : Header;
    OnClose* : C.NotifyEvent;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Toolpanel";
      width        := 150;
      height       := 250;
      NEW(header,SELF);
      header.OnClose := PanelClose;
    END Create;

    PROCEDURE Destroy*;
    BEGIN
      header := NIL;
      Destroy^;
    END Destroy;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
      header.cscolor := header.closecolor;
    END CreateParams;

    PROCEDURE PanelClose*(Sender: C.Object);
    BEGIN
      IF OnClose # NIL THEN OnClose(SELF) END;
    END PanelClose;

    PROCEDURE WMPaint*(VAR message: C.Message);
    BEGIN
    END WMPaint;

    PROCEDURE WMEraseBkgnd*(VAR message: C.Message);
    BEGIN
      message.result := 0;
    END WMEraseBkgnd;

  END;

  Splitter* = POINTER TO RECORD (C.Control)

    bitmap       : G.Bitmap;
    shadowcolor* : Longint;

    curwe        : W.HCursor;
    curns        : W.HCursor;
    cursor       : W.HCursor;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Splitter";
      width        := 4;
      height       := 250;
      color        := G.clSilver;
      shadowcolor  := G.clMedGray;
      align        := C.alRight;
      NEW(bitmap);
      curwe        := W.LoadCursor(0,SYSTEM.VAL(W.LPSTR,W.IDC_SIZEWE));
      curns        := W.LoadCursor(0,SYSTEM.VAL(W.LPSTR,W.IDC_SIZENS));
      cursor       := W.LoadCursor(0,SYSTEM.VAL(W.LPSTR,W.IDC_ARROW));
    END Create;

    PROCEDURE Destroy*;
    BEGIN
      bitmap.Free;
      Destroy^;
    END Destroy;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style := style - W.WS_BORDER;
      CASE align OF
      |  C.alLeft,C.alRight: bitmap.SetSize(width,4*8);
      |  C.alTop,C.alBottom: bitmap.SetSize(4*8,height);
      ELSE
      END;
    END CreateParams;

    PROCEDURE SetCursor;
    BEGIN
      CASE align OF
      |  C.alLeft,C.alRight: W.SetCursor(curwe);
      |  C.alTop,C.alBottom: W.SetCursor(curns);
      ELSE
        W.SetCursor(cursor);
      END;
    END SetCursor;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      W.SetCursor(cursor);
    END WMMouseLeave;

    PROCEDURE WMMouseEnter*;
    BEGIN
      WMMouseEnter^;
      SetCursor;
    END WMMouseEnter;

    PROCEDURE WMMouseUp*(VAR message: C.Message);
    BEGIN
      WMMouseUp^(message);
      SetCursor;
    END WMMouseUp;

    PROCEDURE WMMouseMove*(VAR message: C.Message);
    BEGIN
      WMMouseMove^(message);
      SetCursor;
    END WMMouseMove;

    PROCEDURE WMMouseDown*(VAR message: C.Message);
    BEGIN
      WMMouseUp^(message);
      SetCursor;
    END WMMouseDown;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      dc : W.HDC;
      i  : Longint;
    BEGIN

      dc := W.GetDC(handle);
      bitmap.FillRect(0,0,bitmap.width,bitmap.height,color);

      FOR i := 0 TO 8 DO
        CASE align OF
        |  C.alLeft,C.alRight: bitmap.FillRect(bitmap.width DIV 2-1,i*4,bitmap.width DIV 2 + 1,i*4+2,shadowcolor);
        |  C.alTop,C.alBottom: bitmap.FillRect(i*4, bitmap.height DIV 2-1,i*4+2,bitmap.height DIV 2 + 1,shadowcolor);
        ELSE
        END;
      END;

      CASE align OF
      |  C.alLeft,C.alRight: bitmap.Draw(dc,0,(height - bitmap.height) DIV 2);
      |  C.alTop,C.alBottom: bitmap.Draw(dc,(width - bitmap.width) DIV 2,0);
      ELSE
      END;

      W.ReleaseDC(handle,dc);
    END WMPaint;

    PROCEDURE WMEraseBkgnd*(VAR message: C.Message);
    BEGIN
      message.result := 0;
    END WMEraseBkgnd;

  END;

  Toolbutton* = POINTER TO RECORD (C.Control)

    btnstyle*  : Shortint;
    imageindex*: Longint;

    sepwidth   : Longint;
    leavecolor : Longint;
    entercolor : Longint;
    downcolor  : Longint;
    colorizecl : Longint;
    offset     : W.Point;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      width    := 23;
      height   := 22;
      sepwidth := 5;

      classname    := "Toolbutton";
      IF Parent # NIL THEN
        color  := Parent.color;
      END;

      btnstyle   := tbsButton;

      offset.x   := 0;
      offset.y   := 0;

    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE SetRegion;
    VAR
      reg1,reg2: W.HRgn;
    BEGIN
      reg1 := W.CreateRectRgn(0,0,width,height);
      IF reg1 # 0 THEN
        reg2 := W.CreateRoundRectRgn(0,0,width+1,height+1,2,2);
        IF reg2 # 0 THEN
          W.CombineRgn(reg1,reg1,reg2,W.RGN_AND);
          W.DeleteObject(reg2);
        END;
        W.SetWindowRgn(handle,reg1,W.True);
        W.DeleteObject(reg1);
      END;
    END SetRegion;

    PROCEDURE WMShow*;
    BEGIN
      WMShow^;
      IF btnstyle = tbsButton THEN
        SetRegion;
      ELSIF btnstyle = tbsSeparator THEN
        IF width # sepwidth THEN
          width := sepwidth;
          W.MoveWindow(handle,left,top,width,height,0);
        END;
      END;
    END WMShow;

    PROCEDURE WMEnable*;
    BEGIN
      WMEnable^;
      IF btnstyle = tbsButton THEN
        color  := leavecolor;
      END;
    END WMEnable;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      IF btnstyle = tbsButton THEN
        color  := leavecolor;
      END;
    END WMMouseLeave;

    PROCEDURE WMMouseEnter*;
    BEGIN
      WMMouseEnter^;
      IF btnstyle = tbsButton THEN
        color  := entercolor;
      END;
    END WMMouseEnter;

    PROCEDURE WMMouseDown*(VAR message: C.Message);
    BEGIN
      WMMouseDown^(message);
      IF btnstyle = tbsButton THEN
        color  := downcolor;
        offset.x    := 1;
        offset.y    := 1;
      END;
    END WMMouseDown;

    PROCEDURE WMMouseUp*(VAR message: C.Message);
    BEGIN
      WMMouseUp^(message);
      IF (btnstyle = tbsButton) THEN
        color  := entercolor;
        offset.x    := 0;
        offset.y    := 0;
      END;
    END WMMouseUp;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      pen   : W.HPen;
      dc    : W.HDC;
      parent: Toolbar;
    BEGIN
      dc := W.GetDC(handle);
      IF btnstyle = tbsButton THEN
        parent := owner(Toolbar);
        IF (parent # NIL) & (parent.imagelist # NIL) & (parent.imagelist.count > 0) THEN
          IF (imageindex >= 0) & (imageindex < parent.imagelist.count) THEN
            IF ~ enabled THEN
              color  := parent.color;
              parent.imagelist.Draw(dc,(width - parent.imagelist.width) DIV 2 + offset.x + 1,(height - parent.imagelist.height) DIV 2 + offset.y,imageindex,color,colorizecl,TRUE);
            ELSE
              parent.imagelist.Draw(dc,(width - parent.imagelist.width) DIV 2 + offset.x + 1,(height - parent.imagelist.height) DIV 2 + offset.y,imageindex,color,0,FALSE);
            END;
          END;
        END;
      ELSE
        pen := W.CreatePen(W.PS_SOLID,1,entercolor);
        W.SelectObject(dc, pen);
        W.MoveToEx(dc,width DIV 2,2,NIL);
        W.LineTo(dc,width DIV 2,height-2);
        W.DeleteObject(pen);
      END;
      W.ReleaseDC(handle,dc);
    END WMPaint;

  END;

  Toolbar* = POINTER TO RECORD (C.Control)
    imagelist*   : G.Imagelist;

    leavecolor*  : Longint;
    entercolor*  : Longint;
    downcolor*   : Longint;
    colorizecl*  : Longint;

    btnleft      : Longint;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Toolbar";
      caption      := "";
      align        := C.alTop;
      height       := 26;
      btnleft      := 2;

      leavecolor   := 0E8E8E8H;
      entercolor   := 0D2D2D2H;
      downcolor    := 0DDDDDDH;
      colorizecl   := 0404040H;

    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style   := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE AddButton*(name: String; btnstyle: Shortint): Toolbutton;
    VAR
      btn: Toolbutton;
    BEGIN
      NEW(btn,SELF);
      btn.top := (height - btn.height) DIV 2;
      btn.left := btnleft;
      btn.btnstyle := btnstyle;

      btn.leavecolor := leavecolor;
      btn.entercolor := entercolor;
      btn.downcolor  := downcolor;
      btn.colorizecl := colorizecl;

      IF btnstyle = tbsSeparator THEN
        btn.width := btn.sepwidth;
      END;
      btnleft  := btnleft + btn.width + 1;
      RETURN btn;
    END AddButton;

    PROCEDURE WMSize*(VAR message: C.Message);
    VAR
      i: Longint;
    BEGIN
      WMSize^(message);
      IF controls # NIL THEN
        FOR i := 0 TO controls.count - 1 DO
          IF controls.list[i](C.Control).visible & (controls.list[i](C.Control).left + controls.list[i](C.Control).width > width) THEN
            controls.list[i](C.Control).visible := FALSE;
          ELSIF ~ controls.list[i](C.Control).visible & (controls.list[i](C.Control).left + controls.list[i](C.Control).width <= width) THEN
            controls.list[i](C.Control).visible := TRUE;
          END;
        END;
      END;
    END WMSize;

    PROCEDURE WMPaint*(VAR message: C.Message);
    BEGIN
    END WMPaint;

  END;

  TabNotifyEvent  = PROCEDURE {DELEGATE} (Sender: Tab);

  Tab = POINTER TO RECORD
    name     : Name;
    control  : C.Control;
    active   : Boolean;
    rect     : W.Rect;
    csrect   : W.Rect;
    cscolor  : Longint;
    csactive : Boolean;
    csdown   : Boolean;
  END;

  Tabcontrol* = POINTER TO RECORD (C.Customcontrol)
    tabwidth*     : Longint;
    tabradius*    : Longint;
    tabangle*     : Longint;
    offset*       : Longint;
    count*        : Longint;
    tabs          : Cl.List;
    activetab     : Tab;
    start         : Longint;
    end           : Longint;

    udwidth       : Longint;
    udrect        : W.Rect;

    tabcolor*     : Longint;
    tabframe*     : Longint;
    tableave*     : Longint;
    tabenter*     : Longint;
    tabdown*      : Longint;
    tabfrenter*   : Longint;
    activeframe*  : Longint;
    activecolor*  : Longint;

    textcolor*    : Longint;
    activetext*   : Longint;

    tbcolor       : Longint;
    tbframe       : Longint;
    tabindex      : Longint;

    updowncolor*  : Longint;
    updownframe*  : Longint;
    updownenter*  : Longint;
    updowndown*   : Longint;
    udleftactive  : Boolean;
    udrightactive : Boolean;
    udcolor       : Longint;
    udframe       : Longint;

    cswidth       : Longint;
    closecolor*   : Longint;
    closeenter*   : Longint;

    OnTabClose*   : TabNotifyEvent;
    OnTabDown*    : TabNotifyEvent;
    OnTabActivate*: TabNotifyEvent;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Tabcontrol";
      caption      := "";
      width        := 250;
      height       := 27;

      count        := 0;

      tabwidth     := 105;
      tabradius    := 5;
      tabangle     := 4;
      tabindex     := -1;
      offset       := 10;
      activetab    := NIL;
      start        := 0;
      end          := 0;

      tabcolor     := 0E8E8E8H;
      tabframe     := 0AAAAAAH;
      tableave     := 0E8E8E8H;
      tabenter     := 0D2D2D2H;
      tabfrenter   := G.clMedGray;
      tabdown      := 0DDDDDDH;
      activeframe  := G.clGray;
      activecolor  := G.clWhite;

      textcolor    := tabfrenter;
      activetext   := activeframe;

      tbcolor      := tabcolor;
      tbframe      := tabframe;

      updowncolor  := tabcolor;
      updownframe  := tabframe;
      updownenter  := tabenter;
      updowndown   := tabdown;
      udcolor      := updowncolor;
      udframe      := updownframe;
      udleftactive := FALSE;
      udrightactive:= FALSE;
      udwidth      := 18;

      cswidth      := 10;
      closecolor   := G.clSilver;
      closeenter   := G.clGray;
    END Create;

    PROCEDURE Destroy*;
    VAR
      i: Longint;
    BEGIN
      activetab := NIL;
      IF tabs # NIL THEN
        i := 0;
        WHILE i <= tabs.count-1 DO
          IF tabs.list[i](Tab).control # NIL THEN
            tabs.list[i](Tab).control.Destroy;
          END;
          INC(i);
        END;
        tabs.Clear;
        tabs := NIL;
      END;
      Destroy^;
    END Destroy;

    PROCEDURE SetActive(tab: Tab);
    BEGIN
      IF activetab # NIL THEN
        activetab.active := FALSE;
      END;
      tab.active := TRUE;
      activetab := tab;
      IF OnTabActivate # NIL THEN OnTabActivate(activetab) END;
    END SetActive;

    PROCEDURE AddTab*(name: String; control: C.Control);
    VAR
      tab: Tab;
    BEGIN
      IF tabs = NIL THEN NEW(tabs,0) END;
      NEW(tab);
      COPY(name,tab.name);
      tab.control  := control;
      tab.cscolor  := closecolor;
      tab.csactive := FALSE;
      SetActive(tab);
      tabs.Add(tab);
      INC(count);
      end := (width - (offset+5)*2 - tabwidth - udwidth*2 - offset +5) DIV tabwidth + start;
      IF (end < tabs.count-1) THEN
        INC(start,tabs.count-1-end);
      END;
      W.InvalidateRect(handle,NIL,W.False);
    END AddTab;

    PROCEDURE WMMouseUp*(VAR message: C.Message);
    VAR
      x,y: Longint;
    BEGIN
      WMMouseUp^(message);
      x := C.LoWord(message.lparam);
      y := C.HiWord(message.lparam);

      IF (tabs # NIL) & (tabs.count > 0) & (tabindex >= start) & (tabindex <= end)THEN
        IF tabs.list[tabindex](Tab).csactive & tabs.list[tabindex](Tab).csdown THEN

          IF (tabindex < tabs.count - 1) THEN
            IF start = 0 THEN
              tabs.list[tabindex+1](Tab).csrect := tabs.list[tabindex](Tab).csrect;
              tabs.list[tabindex+1](Tab).csactive := TRUE;
              tabs.list[tabindex+1](Tab).csdown := FALSE;
              tabs.list[tabindex+1](Tab).cscolor := closeenter;
            ELSE
              tabs.list[tabindex-1](Tab).csrect := tabs.list[tabindex](Tab).csrect;
              tabs.list[tabindex-1](Tab).csactive := TRUE;
              tabs.list[tabindex-1](Tab).csdown := FALSE;
              tabs.list[tabindex-1](Tab).cscolor := closeenter;
            END;
          END;

          IF tabs.list[tabindex](Tab).active THEN
            IF tabindex = tabs.count - 1 THEN
              IF tabindex > start THEN
                SetActive(tabs.list[tabindex-1](Tab));
              END;
            ELSIF start > 0 THEN
              SetActive(tabs.list[tabindex-1](Tab));
            ELSE
              SetActive(tabs.list[tabindex+1](Tab));
            END;
          END;

          IF OnTabClose # NIL THEN OnTabClose(tabs.list[tabindex](Tab)) END;

          IF tabs.list[tabindex](Tab).control # NIL THEN
            tabs.list[tabindex](Tab).control.Destroy;
            W.DestroyWindow(tabs.list[tabindex](Tab).control.handle);
          END;
          tabs.Remove(tabs.list[tabindex](Tab));

          IF start > 0 THEN
            DEC(start);
          END;

          DEC(end);
          DEC(count);
          W.InvalidateRect(handle,NIL,W.False);
        END;
      END;

    END WMMouseUp;

    PROCEDURE WMMouseDown*(VAR message: C.Message);
    BEGIN
      WMMouseDown^(message);
      IF udleftactive OR udrightactive THEN
        udcolor := updowndown;
        IF udleftactive THEN
          start := start + 1;
        ELSIF udrightactive THEN
          start := start - 1;
          IF start < 0 THEN start := 0; END;
        END;
        W.InvalidateRect(handle,NIL,W.False);
      ELSIF (tabs # NIL) & (tabs.count > 0) & (tabindex >= start) & (tabindex <= end)THEN
        IF tabs.list[tabindex](Tab).csactive THEN
           tabs.list[tabindex](Tab).csdown := TRUE;
        ELSE
          SetActive(tabs.list[tabindex](Tab));
          IF OnTabDown # NIL THEN OnTabDown(tabs.list[tabindex](Tab)) END;
          W.InvalidateRect(handle,tabs.list[tabindex](Tab).rect,W.False);
          tabs.list[tabindex](Tab).csdown := FALSE;
        END;
      END;
    END WMMouseDown;

    PROCEDURE WMMouseMove*(VAR message: C.Message);
    VAR
      x,y,i : Longint;
      rect  : W.Rect;
      index : Longint;
    BEGIN
      WMMouseMove^(message);
      x := C.LoWord(message.lparam);
      y := C.HiWord(message.lparam);
      udleftactive := FALSE;
      udrightactive:= FALSE;
      IF C.XYInRect(x,y,udrect) THEN
        udcolor      := updownenter;
        rect := udrect;
        DEC(rect.right,(rect.right - rect.left) DIV 2);
        IF C.XYInRect(x,y,rect) THEN
          udleftactive := TRUE;
        ELSE
          udrightactive:= TRUE;
        END;
        tbcolor := tabcolor;
        tbframe := tabframe;
      END;
      W.InvalidateRect(handle,udrect,W.False);

      IF (tabs # NIL) & (tabs.count > 0) THEN
        index    := tabindex;
        tabindex := (x-(offset+5)) DIV tabwidth + start;

        IF (tabindex >= start) & (tabindex <= end)THEN
          tabs.list[tabindex](Tab).cscolor  := closecolor;
          IF C.XYInRect(x,y,tabs.list[tabindex](Tab).csrect) THEN
            tabs.list[tabindex](Tab).cscolor := closeenter;
            tabs.list[tabindex](Tab).csactive := TRUE;
          ELSE
            tabs.list[tabindex](Tab).csactive := FALSE;
          END;
        END;

        IF (index # tabindex) & (tabindex >= start) & (tabindex <= end)THEN
          tbcolor := tabenter;
          tbframe := tabfrenter;
          FOR i := start TO end DO
            IF i # tabindex THEN
              tabs.list[i](Tab).cscolor := closecolor;
              W.InvalidateRect(handle,tabs.list[tabindex](Tab).csrect,W.False);
            END;
          END;
          W.InvalidateRect(handle,tabs.list[tabindex](Tab).rect,W.False);
        ELSE
          W.InvalidateRect(handle,NIL,W.False);
        END;
      END;

    END WMMouseMove;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      tabindex := -1;
      IF udleftactive OR udrightactive THEN
        udleftactive := FALSE;
        udrightactive:= FALSE;
        W.InvalidateRect(handle,udrect,W.False);
      END;
      W.InvalidateRect(handle,NIL,W.False);
    END WMMouseLeave;

    PROCEDURE FillPrizm(x1,y1,x2,y2,o,c1: Longint);
    VAR
      dx,dy,i,sx,sy,e,x,y,c:Longint;
      chk: Boolean;
    BEGIN

      dx := ABS(x1-x2);
      dy := ABS(y1-y2);
      sx := G.Sign(x2-x1);
      sy := G.Sign(y2-y1);
      x  := x1;
      y  := y1;
      chk:= FALSE;

      IF dy>dx THEN
        dx := dx+dy;
        dy := dx-dy;
        dx := dx-dy;
        chk:= TRUE;
      END;

      e:= 2 * dy - dx;

      FOR i:=0 TO dx DO
        canvas.Line(x+o,y,tabwidth+o-x+1,y,c1);
        IF e>=0 THEN
          IF chk THEN x:=x+sx ELSE y:=y+sy; END;
          e:=e-2*dx;
        END;
        IF chk THEN y:=y+sy ELSE x:=x+sx; END;
        e:=e+2*dy;
      END;

    END FillPrizm;

    PROCEDURE DrawClose(tab: Tab; c: Longint);
    VAR
      xc,yc,r: Longint;
    BEGIN
      r  := (tab.csrect.right - tab.csrect.left) DIV 2;
      xc := tab.csrect.left + r;
      yc := tab.csrect.top  + r;
      canvas.AntialiasCircle(xc,yc,r,tab.cscolor,tab.cscolor,TRUE);
      canvas.Line(xc-2,yc-2,xc+2,yc+2,c);
      canvas.Line(xc-2,yc+2,xc+2,yc-2,c);
    END DrawClose;

    PROCEDURE DrawTab(tab: Tab; c1,c2: Longint);
    BEGIN
      canvas.AntialiasCircle(tab.rect.left+tabradius+tabangle+1,tab.rect.top+tabradius,tabradius,c1,c2,TRUE);
      canvas.AntialiasCircle(tab.rect.right-tabradius-tabangle-1,tab.rect.top+tabradius,tabradius,c1,c2,TRUE);
      canvas.FillRect(tab.rect.left+tabradius+tabangle,tab.rect.top,tab.rect.right-tabradius-tabangle,tab.rect.top+tabradius,c2);
      canvas.Line(tab.rect.left+tabradius+tabangle,tab.rect.top,tab.rect.right-tabradius-tabangle,tab.rect.top,c1);
      FillPrizm(0-tabangle,tab.rect.bottom,tabangle,tab.rect.top+tabradius,tab.rect.left,c2);
      canvas.AntialiasLine(tab.rect.left-tabangle,tab.rect.bottom - 1,tab.rect.left+tabangle,tab.rect.top+tabradius,c1);
      canvas.AntialiasLine(tab.rect.right+tabangle,tab.rect.bottom - 1,tab.rect.right-tabangle,tab.rect.top+tabradius,c1);

      canvas.TextOut(tab.rect.left + tabangle + tabradius + 5,tab.rect.top + (tab.rect.bottom - tab.rect.top - canvas.font.height) DIV 2,tab.name);

      tab.csrect.left   := tab.rect.right - cswidth - tabangle - tabradius;
      tab.csrect.top    := tab.rect.top + (tab.rect.bottom - tab.rect.top - cswidth) DIV 2;
      tab.csrect.right  := tab.rect.right - tabangle - tabradius;
      tab.csrect.bottom := tab.csrect.top + cswidth;
      DrawClose(tab,c2);
    END DrawTab;

    PROCEDURE DrawUpDown(rect: W.Rect);
    VAR
      xc,yc,r,c1,c2: Longint;
    BEGIN
      c1 := activeframe;
      c2 := updowncolor;
      IF udleftactive THEN
        c2 := udcolor;
      END;

      r := (rect.right - rect.left) DIV 4;
      xc := rect.left + r;
      yc := rect.top  + r;
      canvas.AntialiasCircle(xc,yc,r,c1,c2,TRUE);
      canvas.FillRect(rect.left + r,rect.top,rect.left + r * 2 + 1,rect.bottom+1,c2);
      canvas.Line(rect.left + r,rect.top,rect.left + r * 2 + 1,rect.top,c1);
      canvas.Line(rect.left + r,rect.bottom,rect.left + r * 2 + 1,rect.bottom,c1);

      canvas.Line(xc,yc,xc+3,yc-3,c1);
      canvas.Line(xc,yc,xc+3,yc+3,c1);
      canvas.Line(xc-2,yc,xc+3-2,yc-3,c1);
      canvas.Line(xc-2,yc,xc+3-2,yc+3,c1);

      c1 := activeframe;
      c2 := updowncolor;
      IF udrightactive THEN
        c2 := udcolor;
      END;

      xc := rect.right - r;
      canvas.AntialiasCircle(xc,yc,r,c1,c2,TRUE);
      canvas.FillRect(rect.left + r * 2,rect.top,rect.right - r,rect.bottom+1,c2);
      canvas.Line(rect.left + r * 2,rect.top,rect.right - r,rect.top,c1);
      canvas.Line(rect.left + r * 2,rect.bottom,rect.right - r,rect.bottom,c1);

      canvas.Line(xc,yc,xc-3,yc-3,c1);
      canvas.Line(xc,yc,xc-3,yc+3,c1);
      canvas.Line(xc+2,yc,xc-3+2,yc-3,c1);
      canvas.Line(xc+2,yc,xc-3+2,yc+3,c1);

      canvas.Line(rect.left + r * 2,rect.top + 2,rect.left + r * 2,rect.bottom-1,c1);
    END DrawUpDown;

    PROCEDURE Paint*;
    VAR
      i,len  : Longint;
      updown : Boolean;
      acttab : Longint;
      fc,bc  : Longint;
    BEGIN
      IF tabs # NIL THEN

        updown := FALSE;
        i := start;
        end := (width - (offset+5)*2 - tabwidth - udwidth*2 - offset + 5) DIV tabwidth + i;
        len := end - start;

        IF start + len > tabs.count-1 THEN
          DEC(start,start + len - (tabs.count - 1));
          IF start < 0 THEN start := 0 END;
          i := start;
        END;

        IF end > tabs.count-1 THEN
          end := tabs.count-1;
        END;

        IF (i>0) OR (end < tabs.count-1) THEN updown := TRUE END;

        acttab := -1;
        WHILE i <= end DO
          tabs.list[i](Tab).rect.left   := offset + 5 + (i-start)*tabwidth;
          tabs.list[i](Tab).rect.top    := 2;
          tabs.list[i](Tab).rect.right  := tabs.list[i](Tab).rect.left+tabwidth;
          tabs.list[i](Tab).rect.bottom := height - 1;
          IF ~ tabs.list[i](Tab).active THEN
            fc := tabframe;
            bc := tableave;
            IF i = tabindex THEN
              fc := tbframe;
              bc := tbcolor;
            END;
            canvas.font.color := textcolor;
            DrawTab(tabs.list[i](Tab),fc,bc);
          ELSE
            acttab := i;
          END;
          INC(i);
        END;
        IF acttab # -1 THEN
          canvas.font.color := activetext;
          DrawTab(tabs.list[acttab](Tab),activeframe,activecolor);
          canvas.Line(offset - 5,tabs.list[acttab](Tab).rect.bottom,tabs.list[acttab](Tab).rect.left - tabangle,tabs.list[acttab](Tab).rect.bottom,activeframe);
          canvas.Line(tabs.list[acttab](Tab).rect.right + tabangle + 1,tabs.list[acttab](Tab).rect.bottom,width - offset + 5,tabs.list[acttab](Tab).rect.bottom,activeframe);
        ELSE
          canvas.Line(offset - 5,height - 1,width - offset + 5,height - 1,activeframe);
        END;

        IF updown THEN
          udrect.left   := width - offset + 5 - udwidth*2;
          udrect.top    := (height - udwidth) DIV 2;
          udrect.right  := width - offset + 5;
          udrect.bottom := (height + udwidth) DIV 2;;
          DrawUpDown(udrect);
        END;

      ELSE
        canvas.Line(offset - 5,height - 1,width - offset + 5,height - 1,activeframe);
      END;
    END Paint;

  END;

  Pagecontrol* = POINTER TO RECORD (C.Control)
    tabcontrol : Tabcontrol;
    bitmap     : G.Bitmap;

    activepage*: C.Control;
    count*     : Longint;

    tabcolor*     : Longint;
    tabframe*     : Longint;
    tableave*     : Longint;
    tabenter*     : Longint;
    tabdown*      : Longint;
    tabfrenter*   : Longint;
    activeframe*  : Longint;
    activecolor*  : Longint;

    textcolor*    : Longint;
    activetext*   : Longint;
    updowncolor*  : Longint;
    updownframe*  : Longint;
    updownenter*  : Longint;
    updowndown*   : Longint;
    closecolor*   : Longint;
    closeenter*   : Longint;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Pagecontrol";
      width        := 250;
      height       := 250;
      activepage   := NIL;
      NEW(tabcontrol,SELF);
      tabcontrol.align := C.alTop;
      tabcontrol.OnTabClose    := TabClose;
      tabcontrol.OnTabActivate := TabActivate;
      count        := 0;

      tabcolor     := 0E8E8E8H;
      tabframe     := 0AAAAAAH;
      tableave     := 0E8E8E8H;
      tabenter     := 0D2D2D2H;
      tabfrenter   := G.clMedGray;
      tabdown      := 0DDDDDDH;
      activeframe  := G.clGray;
      activecolor  := G.clWhite;

      textcolor    := tabfrenter;
      activetext   := activeframe;

      updowncolor  := tabcolor;
      updownframe  := tabframe;
      updownenter  := tabenter;
      updowndown   := tabdown;

      closecolor   := G.clSilver;
      closeenter   := G.clGray;

      NEW(bitmap);
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      tabcontrol.color       := color;
      tabcontrol.tabcolor    := tabcolor;
      tabcontrol.tabframe    := tabframe;
      tabcontrol.tableave    := tableave;
      tabcontrol.tabenter    := tabenter;
      tabcontrol.tabfrenter  := tabfrenter;
      tabcontrol.tabdown     := tabcontrol.tabfrenter;
      tabcontrol.activeframe := activeframe;
      tabcontrol.closecolor  := closecolor;
      tabcontrol.closeenter  := closeenter;
      tabcontrol.textcolor   := tabcontrol.activeframe;
      tabcontrol.activetext  := tabcontrol.activeframe;

      tabcontrol.updowncolor := tabcontrol.tabcolor;
      tabcontrol.updownframe := tabcontrol.tabframe;
      tabcontrol.updownenter := tabcontrol.tabenter;
      tabcontrol.updowndown  := tabcontrol.tabdown;
    END CreateParams;

    PROCEDURE Destroy*;
    BEGIN
      activepage := NIL;
      tabcontrol := NIL;
      bitmap.Free;
      Destroy^;
    END Destroy;

    PROCEDURE SetActivePage(VAR page: C.Control);
    BEGIN
      IF activepage # NIL THEN activepage.visible := FALSE; END;
      page.visible := TRUE;
      activepage   := page;
      Resize;
    END SetActivePage;

    PROCEDURE NewPage*(name: Name);
    VAR
      page: C.Control;
    BEGIN
      NEW(page,SELF);
      tabcontrol.AddTab(name,page);
      INC(count);
      page.color := tabcontrol.activecolor;
      SetActivePage(page);
      Resize;
    END NewPage;

    PROCEDURE TabClose(Sender: Tab);
    BEGIN
      DEC(count);
    END TabClose;

    PROCEDURE TabActivate(Sender: Tab);
    BEGIN
      IF Sender.control # NIL THEN
        SetActivePage(Sender.control);
      END;
    END TabActivate;

    PROCEDURE Resize*;
    BEGIN
      IF activepage # NIL THEN
        activepage.left  := tabcontrol.offset - 5;
        activepage.top   := tabcontrol.height;
        activepage.width := width  - tabcontrol.offset;
        activepage.height:= height - tabcontrol.height - 5;
      END;
    END Resize;

    PROCEDURE WMSize*(VAR message: C.Message);
    BEGIN
      WMSize^(message);
      Resize;
    END WMSize;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      dc  : W.HDC;
      pen : W.HPen;
    BEGIN
      dc := W.GetDC(handle);
      pen := W.CreatePen(W.PS_SOLID,1,activeframe);
      W.SelectObject(dc, pen);

      W.MoveToEx(dc,tabcontrol.offset - 5 - 1,tabcontrol.height,NIL);
      W.LineTo(dc,tabcontrol.offset - 5 - 1,height - 5);
      W.MoveToEx(dc,tabcontrol.offset - 5,height - 5,NIL);
      W.LineTo(dc,width - tabcontrol.offset + 5,height - 5);
      W.MoveToEx(dc,width - tabcontrol.offset + 5,height - 5 - 1,NIL);
      W.LineTo(dc,width - tabcontrol.offset + 5,tabcontrol.height - 1);

      W.DeleteObject(pen);
      W.ReleaseDC(handle,dc);
    END WMPaint;

  END;

END Extctrls.

